#!/usr/local/bin/perl
###############################################################
#LectureBot, copyrighted 1998 by Todd Freitag                     
#All rights reserved. This program may only be used, modified,
#and/or distributed by non-commercially involved sites or for 
#personal(not for profit) use.
###############################################################

#########################################################
#Change these to fit your system, preference, and ICS.
$myDir= "/home/toddmf/lecbot";
$verbose=0;
$log=0;
$logFile= "$myDir/log";
$rhostname = "freechess.org";
$port=5000;
$login="LectureBot";
$password="passwordhere";
#########################################################

$version="1.24";
use Socket;

#Connect to ICS
$sockaddr = 'S n a4 x8';
chop($hostname = `hostname`);

($name, $aliases, $proto) = getprotobyname('tcp');
($name, $aliases, $type, $len, $thisaddr) = gethostbyname($hostname);
($name, $aliases, $type, $len, $thataddr) = gethostbyname($rhostname);

$this = pack($sockaddr, &AF_INET, 0, $thisaddr);
$that = pack($sockaddr, &AF_INET, $port, $thataddr);

socket(S, &PF_INET, &SOCK_STREAM, $proto) || die "socket: $!";
bind(S, $this) || die "bind: $!";
connect(S, $that) || die "connect: $!";
print "Connected\n";

select(S); $|=1;  select(stdout);
login_loop: {
  while(<S>) {
    if (/If you are not a registered player/) {  
	print S "$login\n";
        print S "$password\n";
        last login_loop;
    }
  }
}

#initializations
$justLoggedIn=1;
$isLecture=0;
getLecData();
$numLecs=@lecTopic;
$curLecNum=0; #So that we later start with announcing, rather than reading the 1st lecture
getsu();
$numsu=@sulist;
$SIG{'ALRM'}='readLec';

lectureloop:
readLec();
while(<S>) {
$_ =~ s/[\n]//g; #read a line
$lastLine=$_;
if ($verbose==1) {print "$_\n";}; 
if (/^([^ ]+)\(67\):/) {
  if ($log) {
      s/^.//; #remove the mysterious invisible character
      open(FILE,">>$logFile") or die "Can't open $logFile: $!";
      print FILE "$_\n" or die "Can't print to $logFile: $!";
      close(FILE) or die "Can't close $logFile: $!";
  }
  $user = $1;
  $_ = $user;
      if (/([^\(]*)\(/) {
	  $user = $1;}
  $_=$lastLine;
  if ((/lecture/i) && !(/$login\(TD\)/))
    {if ($isLecture) #respond to "lecture" in 67 except to your own tells
      {print S "qtell 67 $login\(TD\)\(67\): Hi $user! A lecture is in progress:\\n                    \"@lecTopic[$curLecNum-1]\"\\n                    \"observe $login\" to watch.\n";} 
     else {print S "qtell 67 $login\(TD\)\(67\): Hi $user! There is no lecture in progress.\\n                    \"finger $login\" for information about the next\\n                    lecture.\n";}
    }
  }
elsif (/^([^ ]+) tells you: (.*)/) {
      if ($log) {
         s/^.//;
         open(FILE,">>$logFile") or die "Can't open $logFile: $!";
         print FILE "$_\n" or die "Can't print to $logFile: $!";
         close(FILE) or die "Can't close $logFile: $!";
      }
      $user=$1;
      $cmd=$2;
      $_ = $user;
      if (/([^\(]*)\(/) { #Remove designations (TM),(*) etc
	  $user = $1;}      
      $_="_" . $user . "_"; #qwertoddmfasdf is not a super user :)
      s/\W+//;
      $x=0;
      $issu=0;
      until (($x==$numsu) || ($issu==1)) #is user a su?
       {if (/_@sulist[$x]_/) {$issu=1;}
        else {$x++;}
       }
      $_=$cmd;
      s/^\s+//; #remove space, "x tells you:    help     " is ok
      if (/^list/i) 
        {print S "qtell $user $login\'s Lectures:\\n\\n";
	 print S "Number  -  topic  -  author\\n\\n";
         for ($x=0; $x<$numLecs; $x++)
	  {$x++; #lecture numbers start at 1, array subscripts 0
           if ($x<10) {print S "  ";}
	     elsif ($x<100) {print S " ";}
           print S "$x     -  @lecTopic[--$x]  -  ";
           print S @lecAuth[$x];
           if (($isLecture) && ($curLecNum-1==$x)) #$x was --'d 
             {print S " <--";} 
           if (++$x % 10 == 0) #break up long qtells 
             {print S "\n qtell $user ";} 
	   else {print S "\\n";}
           $x--;
          }
         print S "\\n  The lecture in progress is marked by <-- if there is one.\n";           
         }  
      elsif (/^info/i) 
      {print S "qtell $user Information about $login:\\n\\n$login is a perl script that gives lectures on FICS via \"examine\" and\\nrelated commands and responds to tells. $login was written by toddmf\\nwith the code starting a connection on FICS borrowe
d from inj(thanks!)\\n\\n$login\'s Revision history:\\n\\nv0.01 3/7/98   First attempt at sending commands to FICS.\\nv0.2  3/11/98  Tell parser/responder working, basic commands working.\\nv0.22 3/13/98  Parser is more user friendly, channel tells parsed
.\\nv0.40 3/14/98  Super user list and sulist added, commands sent to FICS on\\n               evenly spaced intervals.\\nv0.90 3/15/98  Gives lectures read in from text files.\\nv1.00 3/15/98  Fully functional. Delays are read in from the same text file\
\n               and finger notes are updated.\\nv1.01 3/15/98  Bug fixes, formatting improved\\nv1.02 3/16/98  Start and end of every lecture added.\\nv1.20 4/16/98  Full set of commands added, remembers where it left off, many\\n               code opti
mizations.\\n\n";
       print S "qtell $user v1.22 4/26/98  Logging, lecture lengths added.\\nv1.24 5/5/98   List formatted, all lecture data in 1 file.\\n\\nCurrent version: $version\n";
     }
      elsif (/^sulist/i)
        {print S "qtell $user $login\'s super users:\\n\\n";
         foreach (@sulist) {print S "$_"; print S "\\n";}
         print S "\\nThere are $numsu super users.\n"}
      elsif (/^help/i) 
        {print S "qtell $user Use \"tell $login command\".\\n\\nCommand list:\\n\\nhelp          Displays this command list.\\nlist          Displays the list of lectures.\\ninfo          Displays programming info and revision history.\\nsuhelp        Dis
plays $login super user commands.\\nsulist        Displays the list of super users.\n";}
      elsif (/^suhelp/i) 
        {print S "qtell $user Use \"tell $login command\"\\n\\nSuper user command list:\\n\\nnextlec x     Set x as the next lecture(use only during a lecture)\\ngoto x        Start lecture x immediately, aborting any lecture in progress.\\nquit          
$login will quit and return as soon as possible.\\ndie           $login will quit and not automatically return.\\npose x        Issue command x as $login. Limit 1 line.\\naddsu x       Add x to the super user list.\\nrmsu x        Remove x from the super 
user list.\\nupdate        Update lecture, author, and su lists.\n";}
      elsif (/^pose/i)
        {if ($issu) {print S "$cmd\n";} #assumes alias pose @              else {notsu();}
        }
      elsif (/^quit/i)
        { 
         if ($issu) {print S "quit\n";} 
         else {notsu();}
        }
      elsif (/^die/i)
        {if ($issu) 
           {exit 5;}
         else {notsu();}
        }
      elsif (/^addsu(.*)/i)
        {if ($issu)
	  {$_=$1;
           s/^\s+//;
           $newsu=$_;
           open(FILE,">>$myDir/sulist") or die "Can't open sulist: $!";
           print FILE "$newsu\n" or die "Can't print to sulist: $!";
           close(FILE) or die "Can't close sulist: $!";
           getsu(); #update the list
           $numsu=@sulist;
          }     
         else {notsu();}
        }
      elsif (/^rmsu(.*)/i)
        {if ($issu)
	  {$_=$1;
           s/^\s+//;
           $oldsu=$_;
           $FILE="$myDir/sulist"; #use temp files to safely delete
           $old = $FILE;
           $new = "$FILE.tmp.$$";
           $bak = "$File.bak";
           open(OLD, "< $old") or die "Can't open $old: $!";
           open(NEW, "> $new") or die "Can't open $new: $!";
           while (<OLD>)
	    {s/$oldsu\n//i;
             (print NEW $_) or die "Can't write to $new: $!";
	    }
           close(OLD) or die "Can't close $old: $!";
           close(NEW) or die "Can't close $new: $!";
           rename($old, $bak) or die "Can't rename $old to $bak: $!";
           rename($new, $old) or die "Can't rename $new to $old: $!";
           getsu(); #update list
           $numsu=@sulist;
          }
         else {notsu();}
        }
      elsif (/^nextlec(.*)/i)
        {if ($issu)
	  {$_=$1;
           s/^\s+//;
           $nextLec=$_;
           open(FILE,">$myDir/startpt") or die "Can't open startpt: $!";
           print FILE "$nextLec";
           close(FILE) or die "Can't close startpt: $!";     
           print S "set 10 Next Lecture: The next lecture is on @lecTopic[$nextLec-1].\n";          
           $dontChangeLater=1; #don't change startpt again
          }
         else {notsu();}
        } 
      elsif (/^goto(.*)/i)
        {if ($issu)
	  {$_=$1;
           s/^\s+//;
           $gotoLec=$_;
           open(FILE,">$myDir/startpt") or die "Can't open startpt: $!";
           print FILE "$gotoLec";
           close(FILE) or die "Can't close startpt: $!";     
           print S "qtell 67 $login\(TD\)\(67\): I am starting a lecture immediately! The topic is:\\n                    \"@lecTopic[$gotoLec-1]\"\\n\                    \"observe $login\" to watch.\n";
           $didGoto=1;
           print S "unexamine\n";
           print S "examine\n";
           readLec();
          }
         else {notsu();}
        }
      elsif (/^update/i)
        {if ($issu)
	  {getLecData();
           $numLecs=@lecTopic;
           getsu();
           $numsu=@sulist;
          }
         else {notsu();}
        }
      else {print S "qtell $user Invalid command. \"tell $login help\" for a list of valid commands.\n";};
  }
elsif (/^([^ ]+) kibitzes: (.*)/) {
      $_=$1;
      if (!(/$login/i) && ($log)) {
	 $_=$lastLine;
	 s/^.//;
         open(FILE,">>$logFile") or die "Can't open $logFile: $!";
         print FILE "$_\n" or die "Can't print to $logFile: $!";
         close(FILE) or die "Can't close $logFile: $!";
      }
  }
}

sub notsu {print S "qtell $user You are not a $login super user.\n";}

sub getsu {
    $FILE= "$myDir/sulist";
    open(FILE) or die "Can't open sulist: $!";
    @sulist=<FILE>;
    close(FILE) or die "Can't close sulist: $!";
    chop(@sulist);
}

sub getLecData {
    $FILE= "$myDir/lecdata";
    open(FILE) or die "Can't open lecdata: $!";
    @lecData=<FILE>;
    close(FILE) or die "Can't close lecdata: $!";
    $temp=0; 
    foreach (@lecData) {   
       chop;
       (@lecTopic[$temp],@lecAuth[$temp],@lecLength[$temp])=(split(/!/));
       $temp++;
    }  
}

sub whereWasI { #Determines the first lecture to run on startup, also used to determine which lecture to load
    $FILE= "$myDir/startpt";
    open(FILE) or die "Can't open startpt: $!";
    @startPt=<FILE>;
    $curLecNum=@startPt[0];
    close(FILE) or die "Can't close startpt: $!";
    if ($curLecNum == $numLecs) 
      {print S "set 10 Next Lecture: The next lecture is on @lecTopic[0].\n";}
    elsif ($justLoggedIn==0) {print S "set 10 Next Lecture: The next lecture is on \"@lecTopic[$curLecNum].\"\n";}
    elsif ($didGoto==0) 
      {$justLoggedIn=0;
       print S "set 10 Next Lecture: The next lecture is on \"@lecTopic[$curLecNum-1].\"\n";
      }
    else {$didGoto=0; $justLoggedIn=0;}
          
}

sub incrLecNum { #changes current lecture number
    open(FILE,">$myDir/startpt") or die "Can't open startpt: $!";
    if ($curLecNum==$numLecs) {$curLecNum=1}
      else {$curLecNum++;}
    print FILE "$curLecNum";
    close(FILE) or die "Can't close startpt: $!";
}

sub readLec { #read in the lecture and do other stuff related to the fact that a lecture is in progress
    $isLecture=1;
    getLecData(); #Update occasionally so lectures can be added without restart
    $numLecs=@lecTopic;
    if ($didGoto==1) {  
      print S "set 9 Current Lecture: A lecture on \"@lecTopic[$gotoLec-1]\" is in progress. \"observe $login\" to watch.\n";
      }
    else {
    print S "set 9 Current Lecture: A lecture on \"@lecTopic[$curLecNum-1]\" is in progress. \"observe $login\" to watch.\n";
    }
     if ($curLecNum != 0) #The previously mentioned skipping of everything for the first lecture of each login
      {whereWasI();
       $FILE= "$myDir/lec$curLecNum";
       open(FILE) or die "Can't open lec$curLecNum: $!";
       @curLec=<FILE>;
       close(FILE) or die "Can't close lec$curLecNum: $!";
      }
    $linesInLec=@curLec;
    $pos=0;
    $SIG{'ALRM'}='oneLectureLine';
    oneLectureLine();
}

sub oneLectureLine { #Executes one line in a lecture file
    if ($pos<$linesInLec) 
       {$_=@curLec[$pos];
        alarm 4; #Default delay between lines
        if (/^[0-9]/) {alarm $_;} #specified delay
        else {print S "@curLec[$pos]";} #An ICS command
        $pos++;
       } 
    else { #end the lecture, do all end-related stuff
      $isLecture=0;
      print S "kibitz That concludes this lecture. If this lecture inspired you to write your own lecture, \"finger $login\" and read note 8. toddmf would really like to hear from you about $login. Please send him comments! Hope to see you all again soon!

\n"; 
      print S "set 9 Current Lecture: No lecture is in progress.\n";
      $SIG{'ALRM'}='lecAnnounce';
      $annoNum=0;
      if ($curLecNum==0) {whereWasI();} #First lecture on login
        elsif ($dontChangeLater==0) {incrLecNum()} #all later lectures
        else {$dontChangeLater=0;
              $curLecNum=$nextLec;}
      lecAnnounce(); 
         }
}

sub lecAnnounce { #pre-lecture announcements, etc.
    $annoNum++; 
    if ($annoNum==1) 
      {if ($curLecNum>$numLecs) {$curLecNum=1;}
       print S "unexamine\n";
       print S "examine\n";
       print S "qtell 67 $login\(TD\)\(67\): I am starting a lecture in 5 minutes:\\n                    \"@lecTopic[$curLecNum-1]\"\\n                    The lecture lasts about @lecLength[$curLecNum-1] minutes.\\n                    \"observe $login\" t
o watch.\n";
       alarm 120;
      }       
    elsif ($annoNum==2)
      {print S "cshout I am starting a lecture on \"@lecTopic[$curLecNum-1]\" in 3 minutes! The lecture is about @lecLength[$curLecNum-1] minutes long. \"+ch 67\" to join the lecture channel and \"observe $login\" to watch.\n";
       alarm 60;    
      }
    elsif ($annoNum==3)
      {print S "kibitz The lecture is starting in 2 minutes! Grab a snack and get comfortable :)\n";
       alarm 90;
      }
    elsif ($annoNum==4)
      {print S "qtell 67 $login\(TD\)\(67\): I am about to start a lecture!  The topic is:\\n                    @lecTopic[$curLecNum-1]\\n                    It begins in 30 seconds and lasts @lecLength[$curLecNum-1] minutes!\\n                    \"obse
rve $login\" to watch.\n"; 
       alarm 30;
      }
    elsif ($annoNum==5)
      {print S "kibitz Before we get underway, there are a few things you should know.\n";
       alarm 5;
      }
    elsif ($annoNum==6)
      {print S "kibitz If you'd like to know more about $login, \"finger $login\" and \"tell $login help\".\n";
       alarm 10;
      }
    elsif ($annoNum==7)
      {print S "kibitz Direct any questions, comments, suggestions, complaints, etc. about $login or this lecture to toddmf.\n";
       alarm 10;
      }
    elsif ($annoNum==7)
      {print S "kibitz Note: I am a fully automated computer. This means I am unable to answer any questions about the lecture :)\n";
       alarm 10;
      }
    elsif ($annoNum==8)
      {print S "kibitz I am now running on the FICS computer, so I should no longer lag or disconnect often.\n";
       alarm 10;
      }
    elsif ($annoNum==9)
      {print S "kibitz With that out of the way, let's begin the lecture!\n";
       alarm 5;
      }
    elsif ($annoNum==10)
      {print S "kibitz This lecture is on @lecTopic[$curLecNum-1] and was written by @lecAuth[$curLecNum-1]. It lasts about @lecLength[$curLecNum-1] minutes. I hope you enjoy and learn from it!\n";
       $annoNum=0; 
       $SIG{'ALRM'}='readLec'; 
       alarm 13;
      } 
}
